package de.jcg.GUI;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.JPanel;

import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.SwingUtilities;

import de.jcg.Persistence.Database;
import de.jcg.Trainer.Exercise;
import de.jcg.Trainer.Setup;


public class GUI extends javax.swing.JFrame {
	private JPanel contentPane;
	private JTabbedPane auswahl;
	private JList vocList;
	private JLabel hiddenCheckNumberLabel;
	private JLabel hiddenSummarizeLabel;
	private JButton delete;
	private JButton saveVocAndTrans;
	private JTextField saveTrans;
	private JTextField saveVocField;
	private JScrollPane jScrollPane4;
	private JList translateVoc;
	private JScrollPane jScrollPane3;
	private JButton saveButton;
	private JScrollPane jScrollPane2;
	private JLabel translaeteLabel;
	private JPanel setUp;
	private JLabel vocLabel;
	private JLabel hiddenFalseAnswerLabel;
	private JLabel hiddenRightAnswerLabel;
	private JButton answerButton;
	private JTextField answerField;
	private JLabel answerLabel;
	private JLabel hiddenAnswerLabel;
	private JLabel whatMeans;
	private JLabel helpImportLabel;
	private JButton importButton;
	private JSeparator sepSetUp;
	private JButton startExcercise;
	private JTextField jTextField1;
	private JLabel number;
	private JLabel directionLabel;
	private JRadioButton directionTwo;
	private JRadioButton directionOne;
	private JScrollPane jScrollPane1;
	private JLabel loadVocLabel;
	private JList loadVocList;
	private JPanel saveVoc;
	private JPanel exercise;
	
	private Exercise exer;
	private Setup setup;
	

	
	public GUI() {
		super("Vokabeltrainer 1.0");
		initGUI();
		
		exer = new Exercise();
		setup = new Setup();
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			{
				contentPane = new JPanel();
				getContentPane().add(contentPane, BorderLayout.CENTER);
			}
			{
				auswahl = new JTabbedPane();
				contentPane.add(auswahl);
				auswahl.setPreferredSize(new java.awt.Dimension(488, 369));
				{
					setUp = new JPanel();
					GridBagLayout setUpLayout = new GridBagLayout();
					setUpLayout.rowWeights = new double[] {0.1};
					setUpLayout.rowHeights = new int[] {7};
					setUpLayout.columnWeights = new double[] {0.0, 0.1};
					setUpLayout.columnWidths = new int[] {292, 20};
					setUp.setLayout(setUpLayout);
					auswahl.addTab("bung konfigurieren", null, setUp, null);
					setUp.setPreferredSize(new java.awt.Dimension(251, 343));
					{
						jScrollPane1 = new JScrollPane(loadVocList, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
						setUp.add(jScrollPane1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(26, 7, 0, 0), 0, 0));						
						jScrollPane1.setPreferredSize(new java.awt.Dimension(274, 314));
						{
							
							ListModel loadVocListModel = new DefaultListModel();
							loadVocList = new JList(loadVocListModel);
							loadVocList.setModel(loadVocListModel);
							loadVocList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
							jScrollPane1.setViewportView(loadVocList);
							loadVocList.setPreferredSize(new java.awt.Dimension(194, 314));
							loadVocList.setListData(Database.getInstance().getAllFiles());
							
						}
					}
					{
						loadVocLabel = new JLabel();
						setUp.add(loadVocLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(7, 6, 2, 3), 0, 0));
						loadVocLabel.setText("Vokabeln laden:");
					}
					{
						directionOne = new JRadioButton();
						directionOne.setSelected(true);
						directionOne.setActionCommand("first");
						setUp.add(directionOne, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
						directionOne.setText("Sprache 1 --> Sprache 2");
					}
					{
						directionTwo = new JRadioButton();
						directionTwo.setActionCommand("second");
						setUp.add(directionTwo, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(179, 0, 1, 0), 0, 0));
						directionTwo.setText("Sprache 2 --> Sprache 1");
					}
					{
						final ButtonGroup bg = new ButtonGroup();
						bg.add(directionOne);
						bg.add(directionTwo);
						{
							directionLabel = new JLabel();
							setUp.add(directionLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 2, 37, 100), 0, 0));
							directionLabel.setText("Richtung:");
						}
						{
							number = new JLabel();
							setUp.add(number, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 110, 0), 0, 0));
							number.setText("Anzahl zu bender Vokabeln?");
						}
						{
							jTextField1 = new JTextField();
							setUp.add(jTextField1, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 85, 0), 0, 0));
							jTextField1.setPreferredSize(new java.awt.Dimension(49, 21));
						}
						{
							startExcercise = new JButton();
							setUp.add(startExcercise, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 50, 0), 0, 0));
							startExcercise.setText("Zur bung");
							startExcercise.setPreferredSize(new java.awt.Dimension(123, 25));
							startExcercise.addActionListener(new ActionListener() {
								public void actionPerformed(ActionEvent evt) {
									hiddenRightAnswerLabel.setIcon(null);
									hiddenFalseAnswerLabel.setIcon(null);
									Pattern p = Pattern.compile("[1-9]+\\d*");
									Matcher m = p.matcher(jTextField1.getText());
									if(loadVocList.getSelectedIndex() != -1 && m.matches()){
										if(bg.getSelection().getActionCommand().equals("first"))
											Database.getInstance().readFromCSV(loadVocList.getSelectedValue().toString(), true, Integer.parseInt(jTextField1.getText()));
										else
											Database.getInstance().readFromCSV(loadVocList.getSelectedValue().toString(), false, Integer.parseInt(jTextField1.getText()));
										if(Database.getInstance().getVoc().size() < Integer.parseInt(jTextField1.getText()))
											hiddenCheckNumberLabel.setText(loadVocList.getSelectedValue().toString()+" hat nur "+Database.getInstance().getVoc().size()+" Vokabeln");
										else{
											hiddenCheckNumberLabel.setText("");
											int count = Database.getNumberAnswers();
											Database.setNumberAnswers(count -= count -1);	
											int randomIndex = new Random().nextInt(Database.getAllQuestionsNumber());
											Database.getInstance().setSelectedIndex(randomIndex);
											hiddenAnswerLabel.setText(count+". "+exer.nextQuestion(randomIndex));
											answerButton.setEnabled(true);
											hiddenSummarizeLabel.setText("");
											auswahl.setSelectedIndex(1);
										}
									}
								}
							});
						}
						{
							sepSetUp = new JSeparator();
							setUp.add(sepSetUp, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(120, 0, 0, 0), 0, 0));
							sepSetUp.setPreferredSize(new java.awt.Dimension(129, 45));
						}
						{
							importButton = new JButton();
							setUp.add(importButton, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(80, 0, 0, 0), 0, 0));
							importButton.setText("Vokabelliste importieren");
							importButton.setPreferredSize(new java.awt.Dimension(179, 26));
							importButton.addActionListener(new ActionListener() {
								public void actionPerformed(ActionEvent evt) {
									JFileChooser jfc = new JFileChooser(Database.getInstance().HOME);
									int returnVal = jfc.showOpenDialog(GUI.this);
									if(returnVal == JFileChooser.CANCEL_OPTION);
									else{
										try {
											String name = jfc.getSelectedFile().getName();
											setup.importVoc(jfc.getSelectedFile().getCanonicalFile());
											loadVocList.setModel(new DefaultListModel());
											DefaultListModel dlm = new DefaultListModel();
											loadVocList.setModel(dlm);
											dlm.addElement(name);
											loadVocList.setListData(Database.getInstance().getAllFiles());
										} catch (IOException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
									}	
								}
							});
						}
						{
							helpImportLabel = new JLabel();
							setUp.add(helpImportLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(6, 0, 0, 0), 0, 0));
							helpImportLabel.setText("<html><body> Hier kannst Du </br> bereits bestehende </br> Vokabellisten importieren. </body></html>");
							helpImportLabel.setPreferredSize(new java.awt.Dimension(148, 61));
						}
						{
							hiddenCheckNumberLabel = new JLabel();
							setUp.add(hiddenCheckNumberLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 9, 0), 0, 0));
							hiddenCheckNumberLabel.setPreferredSize(new java.awt.Dimension(91, 24));
						}
					}
				}
				{
					exercise = new JPanel();
					GridBagLayout exerciseLayout = new GridBagLayout();
					exerciseLayout.rowWeights = new double[] {0.0, 0.1};
					exerciseLayout.rowHeights = new int[] {171, 7};
					exerciseLayout.columnWeights = new double[] {0.0, 0.1};
					exerciseLayout.columnWidths = new int[] {273, 7};
					exercise.setLayout(exerciseLayout);
					auswahl.addTab("bung", null, exercise, null);
					{
						whatMeans = new JLabel();
						exercise.add(whatMeans, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(50, 0, 0, 0), 0, 0));
						whatMeans.setText("Was heit....?");
						whatMeans.setPreferredSize(new java.awt.Dimension(84, 14));
					}
					{
						hiddenAnswerLabel = new JLabel();
						exercise.add(hiddenAnswerLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
						hiddenAnswerLabel.setPreferredSize(new java.awt.Dimension(86, 32));
					}
					{
						answerLabel = new JLabel();
						exercise.add(answerLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
						answerLabel.setText("Antwort eingeben:");
					}
					{
						answerField = new JTextField();
						exercise.add(answerField, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(40, 17, 0, 17), 0, 0));
						answerField.setPreferredSize(new java.awt.Dimension(204, 27));
					}
					{
						answerButton = new JButton();
						exercise.add(answerButton, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
						answerButton.setText("OK");
						answerButton.setPreferredSize(new java.awt.Dimension(51, 29));
						answerButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								hiddenFalseAnswerLabel.setIcon(null);
								hiddenRightAnswerLabel.setIcon(null);
								int count = Database.getNumberAnswers();
								if(exer.checkAnswer(answerField.getText(), Database.getInstance().getSelectedIndex())) {
									hiddenRightAnswerLabel.setIcon(new ImageIcon("src"+System.getProperty("file.separator")+"pics"+System.getProperty("file.separator")+"daumenHoch.gif"));
								}else{
									hiddenFalseAnswerLabel.setIcon(new ImageIcon("src"+System.getProperty("file.separator")+"pics"+System.getProperty("file.separator")+"daumenRunter.gif"));
								}
								Database.getInstance();
								Database.setNumberAnswers(count -= -1);
								int randomIndex = new Random().nextInt(Database.getAllQuestionsNumber());
								Database.getInstance().setSelectedIndex(randomIndex);
								answerField.setText("");
								if (Database.getAllQuestionsNumber() == count-1) {
									hiddenSummarizeLabel.setText(exer.nextQuestion(randomIndex));
									answerButton.setEnabled(false);
								}else{
									hiddenAnswerLabel.setText(count+". "+exer.nextQuestion(randomIndex));
								}
								
							}
						});
					}
					{
						hiddenRightAnswerLabel = new JLabel();
						exercise.add(hiddenRightAnswerLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 0, 0));
						hiddenRightAnswerLabel.setPreferredSize(new java.awt.Dimension(93, 171));
					}
					{
						hiddenFalseAnswerLabel = new JLabel();
						exercise.add(hiddenFalseAnswerLabel, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 0, 0));
						hiddenFalseAnswerLabel.setPreferredSize(new java.awt.Dimension(88, 172));
					}
					{
						hiddenSummarizeLabel = new JLabel();
						exercise.add(hiddenSummarizeLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(5, 17, 13, 0), 0, 0));
						hiddenSummarizeLabel.setPreferredSize(new java.awt.Dimension(127, 26));
					}
				}
				{
					saveVoc = new JPanel();
					GridBagLayout saveVocLayout = new GridBagLayout();
					auswahl.addTab("Vokabeln hinzufgen", null, saveVoc, null);
					saveVocLayout.rowWeights = new double[] {0.0, 0.1};
					saveVocLayout.rowHeights = new int[] {52, 7};
					saveVocLayout.columnWeights = new double[] {0.0, 0.1};
					saveVocLayout.columnWidths = new int[] {240, 20};
					saveVoc.setLayout(saveVocLayout);
					{
						vocLabel = new JLabel();
						saveVoc.add(vocLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(4, 50, 0, 0), 0, 0));
						vocLabel.setText("Vokabel:");
					}
					{
						translaeteLabel = new JLabel();
						saveVoc.add(translaeteLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(4, 142, 0, 0), 0, 0));
						translaeteLabel.setText("bersetzung:");
					}
					{
						jScrollPane2 = new JScrollPane();
						saveVoc.add(jScrollPane2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(29, 0, 0, 0), 0, 0));
					}
					{
						saveButton = new JButton();
						saveVoc.add(saveButton, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(67, 0, 1, 0), 0, 0));
						saveButton.setText("Speichern");
						saveButton.setPreferredSize(new java.awt.Dimension(145, 33));
						saveButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								JFileChooser jfc = new JFileChooser(Database.getInstance().HOME);
								int returnVal = jfc.showOpenDialog(GUI.this);
								if(returnVal == JFileChooser.CANCEL_OPTION);
								else{
									Database.getInstance().saveToCSV(jfc.getSelectedFile().getName());
									DefaultListModel left = (DefaultListModel) vocList.getModel();
									DefaultListModel right = (DefaultListModel) translateVoc.getModel();
									left.removeAllElements();
									right.removeAllElements();
									loadVocList.setListData(Database.getInstance().getAllFiles());
									auswahl.setSelectedIndex(0);
								}
							}
						});
					}
					{
						jScrollPane3 = new JScrollPane(vocList, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
						saveVoc.add(jScrollPane3, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 17, 0), 0, 0));
						jScrollPane3.setPreferredSize(new java.awt.Dimension(225, 226));
						{
							ListModel vocListModel = new DefaultListModel();
							vocList = new JList(vocListModel);
							jScrollPane3.setViewportView(vocList);
							vocList.setModel(vocListModel);
							vocList.setPreferredSize(new java.awt.Dimension(222, 185));
							vocList.addListSelectionListener(new ListSelectionListener() {
								public void valueChanged(ListSelectionEvent evt) {
									 if (evt.getValueIsAdjusting() == false) {
									        if (vocList.getSelectedIndex() == -1) {
									            delete.setEnabled(false);
//									            saveVocField.setText(vocList.getSelectedValue().toString());
//												translateVoc.setSelectedIndex(vocList.getSelectedIndex());
//												saveTrans.setText(translateVoc.getSelectedValue().toString());
									        } else {
									            delete.setEnabled(true);
									        }
									 }
								}});
						}
					}	
					{
						jScrollPane4 = new JScrollPane(translateVoc, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
						saveVoc.add(jScrollPane4, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 17, 0), 0, 0));
						jScrollPane4.setPreferredSize(new java.awt.Dimension(225, 226));
						{
							ListModel translateVocModel = new DefaultListModel();
							translateVoc = new JList(translateVocModel);
							jScrollPane4.setViewportView(translateVoc);
							translateVoc.setModel(translateVocModel);
							translateVoc.setPreferredSize(new java.awt.Dimension(222, 185));
							translateVoc.addListSelectionListener(new ListSelectionListener() {
								public void valueChanged(ListSelectionEvent evt) {
									if (evt.getValueIsAdjusting() == false) {
								        if (vocList.getSelectedIndex() == -1) 
								            delete.setEnabled(false);
								        else {
								        	delete.setEnabled(true); 
								        	translateVoc.setSelectedIndex(vocList.getSelectedIndex());
								        }    
									}
								}
							});
						}
					}
					{
						saveVocField = new JTextField();
						saveVoc.add(saveVocField, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(20, 20, 0, 0), 0, 0));
						saveVocField.setPreferredSize(new java.awt.Dimension(100, 21));
					}
					{
						saveTrans = new JTextField();
						saveVoc.add(saveTrans, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(20, 0, 0, 0), 0, 0));
						saveTrans.setPreferredSize(new java.awt.Dimension(100, 21));
					}
					{
						saveVocAndTrans = new JButton();
						saveVoc.add(saveVocAndTrans, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(20, 10, 0, 0), 0, 0));
						saveVocAndTrans.setText("Hinzufgen");
						saveVocAndTrans.setPreferredSize(new java.awt.Dimension(114, 21));
						saveVocAndTrans.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								String voc = saveVocField.getText();
								String translation = saveTrans.getText();

								if(voc.length() > 0 && translation.length() > 0){
									Database.getInstance().saveToRAM(voc, translation);
									DefaultListModel dlmLeft = (DefaultListModel) vocList.getModel();
									dlmLeft.addElement(voc);
									DefaultListModel dlmRight = (DefaultListModel) translateVoc.getModel();
									dlmRight.addElement(translation);
								}
								saveVocField.setText("");
								saveTrans.setText("");
							}
						});
					}
					{
						delete = new JButton();
						saveVoc.add(delete, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(20, 10, 0, 17), 0, 0));
						delete.setText("Entfernen");
						delete.setEnabled(false);
						delete.setPreferredSize(new java.awt.Dimension(99, 21));
						delete.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								if(vocList.getModel().getSize() == 0)
									delete.setEnabled(false);
								else{
									DefaultListModel dlmLeft = (DefaultListModel) vocList.getModel();
									int leftIndex;
									dlmLeft.remove(leftIndex = vocList.getSelectedIndex());
									DefaultListModel dlmRight = (DefaultListModel) translateVoc.getModel();
									dlmRight.remove(leftIndex);
									Database.getInstance().delFromRAM(saveVocField.getText(), saveTrans.getText());
									vocList.repaint();
									translateVoc.repaint();
								}	
							}
						});
					}
				}

			}
		
			pack();
			setSize(500, 400);
		} catch (Exception e) {
		   
			e.printStackTrace();
		}
	}

	

	public JTabbedPane getAuswahl() {
		return auswahl;
	}

	public JList getVocList() {
		return vocList;
	}

	public JScrollPane getjScrollPane4() {
		return jScrollPane4;
	}

	public JList getTranslateVoc() {
		return translateVoc;
	}

	public JScrollPane getjScrollPane3() {
		return jScrollPane3;
	}

	public JButton getSaveButton() {
		return saveButton;
	}

	public JScrollPane getjScrollPane2() {
		return jScrollPane2;
	}

	public JLabel getTranslaeteLabel() {
		return translaeteLabel;
	}

	public JPanel getSetUp() {
		return setUp;
	}

	public JLabel getVocLabel() {
		return vocLabel;
	}

	public JLabel getHiddenFalseAnswerLabel() {
		return hiddenFalseAnswerLabel;
	}

	public JLabel getHiddenRightAnswerLabel() {
		return hiddenRightAnswerLabel;
	}

	public JButton getAnswerButton() {
		return answerButton;
	}

	public JTextField getAnswerField() {
		return answerField;
	}

	public JLabel getAnswerLabel() {
		return answerLabel;
	}

	public JLabel getHiddenAnswerLabel() {
		return hiddenAnswerLabel;
	}

	public JLabel getWhatMeans() {
		return whatMeans;
	}

	public JLabel getHelpImportLabel() {
		return helpImportLabel;
	}

	public JButton getImportButton() {
		return importButton;
	}

	public JSeparator getSepSetUp() {
		return sepSetUp;
	}

	public JButton getStartExcercise() {
		return startExcercise;
	}

	public JTextField getjTextField1() {
		return jTextField1;
	}

	public JLabel getNumber() {
		return number;
	}

	public JLabel getDirectionLabel() {
		return directionLabel;
	}

	public JRadioButton getDirectionTwo() {
		return directionTwo;
	}

	public JRadioButton getDirectionOne() {
		return directionOne;
	}

	public JScrollPane getjScrollPane1() {
		return jScrollPane1;
	}

	public JLabel getLoadVocLabel() {
		return loadVocLabel;
	}

	public JList getLoadVocList() {
		return loadVocList;
	}

	public JPanel getSaveVoc() {
		return saveVoc;
	}

	public JPanel getExercise() {
		return exercise;
	}

	public Exercise getExer() {
		return exer;
	}

	public Setup getSetup() {
		return setup;
	}

}
